"use strict";Object.defineProperty(exports, "__esModule", {value: true}); function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { newObj[key] = obj[key]; } } } newObj.default = obj; return newObj; } } function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};

// src/index.ts
var _crypto = require('crypto'); var _crypto2 = _interopRequireDefault(_crypto);
var _path2 = require('path'); var _path3 = _interopRequireDefault(_path2);
var _core = require('@babel/core'); var babel = _interopRequireWildcard(_core);
var _babelpluginjsx = require('@vue/babel-plugin-jsx'); var _babelpluginjsx2 = _interopRequireDefault(_babelpluginjsx);
var _typescript = require('typescript'); var _typescript2 = _interopRequireDefault(_typescript);
var _vite = require('vite');
var ssrRegisterHelperId = "/__vue-jsx-ssr-register-helper";
var ssrRegisterHelperCode = `import { useSSRContext } from "vue"
export const ssrRegisterHelper = ${ssrRegisterHelper.toString()}`;
function ssrRegisterHelper(comp, filename) {
  const setup = comp.setup;
  comp.setup = (props, ctx) => {
    const ssrContext = useSSRContext();
    (ssrContext.modules || (ssrContext.modules = /* @__PURE__ */ new Set())).add(filename);
    if (setup) {
      return setup(props, ctx);
    }
  };
}
function vueJsxPlugin(options = {}) {
  let root = "";
  let needHmr = false;
  let needSourceMap = true;
  let tsconfig;
  let isProd = false;
  const _a2 = options, {
    include,
    exclude,
    babelPlugins = [],
    defineComponentName = ["defineComponent"],
    tsPluginOptions: tsPluginOptions = {}
  } = _a2, babelPluginOptions = __objRest(_a2, [
    "include",
    "exclude",
    "babelPlugins",
    "defineComponentName",
    // eslint-disable-next-line @typescript-eslint/no-unused-vars
    "tsPluginOptions"
  ]);
  const filter = _vite.createFilter.call(void 0, include || /\.(jsx|tsx?)/, exclude || /\.esbuild\./);
  return {
    name: "vue3-oop:vue-jsx",
    config(config) {
      var _a3, _b, _c, _d, _e, _f;
      const parseDefine = (v) => {
        try {
          return typeof v === "string" ? JSON.parse(v) : v;
        } catch (err) {
          return v;
        }
      };
      return {
        // support ts decorators to use tsc compile
        esbuild: {
          include: /\.esbuild\./
        },
        define: {
          __VUE_OPTIONS_API__: (_b = parseDefine((_a3 = config.define) == null ? void 0 : _a3.__VUE_OPTIONS_API__)) != null ? _b : true,
          __VUE_PROD_DEVTOOLS__: (_d = parseDefine((_c = config.define) == null ? void 0 : _c.__VUE_PROD_DEVTOOLS__)) != null ? _d : false,
          __VUE_PROD_HYDRATION_MISMATCH_DETAILS__: (_f = parseDefine((_e = config.define) == null ? void 0 : _e.__VUE_PROD_HYDRATION_MISMATCH_DETAILS__)) != null ? _f : false
        }
      };
    },
    configResolved(config) {
      needHmr = config.command === "serve" && !config.isProduction;
      needSourceMap = config.command === "serve" || !!config.build.sourcemap;
      root = config.root;
      isProd = config.isProduction;
    },
    resolveId(id) {
      if (id === ssrRegisterHelperId) {
        return id;
      }
    },
    load(id) {
      if (id === ssrRegisterHelperId) {
        return ssrRegisterHelperCode;
      }
    },
    transform(code, id, opt) {
      var _a3;
      const ssr = (opt == null ? void 0 : opt.ssr) === true;
      const [filepath] = id.split("?");
      if (filter(id) || filter(filepath)) {
        const plugins = [[_babelpluginjsx2.default, babelPluginOptions], ...babelPlugins];
        if (/\.tsx?/.test(id)) {
          if (!tsconfig) {
            const configPath = _typescript2.default.findConfigFile("./", _typescript2.default.sys.fileExists, "tsconfig.json");
            if (!configPath) {
              throw new Error('Could not find a valid "tsconfig.json".');
            }
            tsconfig = _typescript2.default.parseJsonConfigFileContent(
              { extends: "./tsconfig.json" },
              _typescript2.default.sys,
              _path3.default.dirname(_path3.default.resolve(configPath))
            );
            if (!tsconfig.options) {
              tsconfig.options = {};
            }
            Object.assign(tsconfig.options, {
              sourceMap: isProd && needSourceMap,
              inlineSourceMap: !isProd && needSourceMap,
              inlineSources: !isProd && needSourceMap
            });
          }
          const { outputText, diagnostics, sourceMapText } = _typescript2.default.transpileModule(code, {
            compilerOptions: tsconfig.options,
            fileName: id,
            reportDiagnostics: true
          });
          if (diagnostics == null ? void 0 : diagnostics[0]) {
            throw new Error((_a3 = diagnostics == null ? void 0 : diagnostics[0]) == null ? void 0 : _a3.messageText);
          }
          code = outputText;
          if (!id.endsWith("x")) {
            return {
              code,
              map: isProd && needSourceMap ? sourceMapText : void 0
            };
          }
        }
        if (!ssr && !needHmr) {
          plugins.push(() => {
            return {
              visitor: {
                CallExpression: {
                  enter(_path) {
                    if (isDefineComponentCall(_path.node, defineComponentName)) {
                      const callee = _path.node.callee;
                      callee.name = `/* @__PURE__ */ ${callee.name}`;
                    }
                  }
                }
              }
            };
          });
        }
        const result = babel.transformSync(code, {
          babelrc: false,
          ast: true,
          plugins,
          sourceMaps: needSourceMap,
          sourceFileName: id,
          configFile: false
        });
        if (!ssr && !needHmr) {
          if (!result.code) {
            return;
          }
          return {
            code: result.code,
            map: result.map
          };
        }
        const declaredComponents = [];
        const hotComponents = [];
        let hasDefault = false;
        for (const node of result.ast.program.body) {
          if (node.type === "VariableDeclaration") {
            const names = parseComponentDecls(node, defineComponentName);
            if (names.length) {
              declaredComponents.push(...names);
            }
          }
          if (node.type === "ClassDeclaration" && isExtendClassComponet(node)) {
            declaredComponents.push(node.id.name);
            continue;
          }
          if (node.type === "ExportNamedDeclaration") {
            if (node.declaration && node.declaration.type === "VariableDeclaration") {
              hotComponents.push(
                ...parseComponentDecls(node.declaration, defineComponentName).map((name) => ({
                  local: name,
                  exported: name,
                  id: getHash(id + name)
                }))
              );
            } else if (node.declaration && node.declaration.type === "ClassDeclaration" && isExtendClassComponet(node.declaration)) {
              const name = node.declaration.id.name;
              hotComponents.push({
                local: name,
                exported: name,
                id: getHash(id + name)
              });
            } else if (node.specifiers.length) {
              for (const spec of node.specifiers) {
                if (spec.type === "ExportSpecifier" && spec.exported.type === "Identifier") {
                  const matched = declaredComponents.find((name) => name === spec.local.name);
                  if (matched) {
                    hotComponents.push({
                      local: spec.local.name,
                      exported: spec.exported.name,
                      id: getHash(id + spec.exported.name)
                    });
                  }
                }
              }
            }
          }
          if (node.type === "ExportDefaultDeclaration") {
            if (node.declaration.type === "Identifier") {
              const _name = node.declaration.name;
              const matched = declaredComponents.find((name) => name === _name);
              if (matched) {
                hotComponents.push({
                  local: _name,
                  exported: "default",
                  id: getHash(id + "default")
                });
              }
            } else if (isDefineComponentCall(node.declaration, defineComponentName)) {
              hasDefault = true;
              hotComponents.push({
                local: "__default__",
                exported: "default",
                id: getHash(id + "default")
              });
            } else if (node.declaration && node.declaration.type === "ClassDeclaration" && isExtendClassComponet(node.declaration)) {
              const name = node.declaration.id.name;
              hotComponents.push({
                local: name,
                exported: "default",
                id: getHash(id + name)
              });
            }
          }
        }
        if (hotComponents.length) {
          if (hasDefault && (needHmr || ssr)) {
            result.code = result.code.replace(/export default defineComponent/g, `const __default__ = defineComponent`) + `
export default __default__`;
          }
          if (needHmr && !ssr && !/\?vue&type=script/.test(id)) {
            let code2 = result.code;
            let callbackCode = ``;
            for (const { local, exported, id: id2 } of hotComponents) {
              code2 += `
${local}.__hmrId = "${id2}"
__VUE_HMR_RUNTIME__.createRecord("${id2}", ${local})`;
              callbackCode += `
__VUE_HMR_RUNTIME__.reload("${id2}", __${exported})`;
            }
            const newCompNames = hotComponents.map((c) => `${c.exported}: __${c.exported}`).join(",");
            code2 += `
import.meta.hot.accept(({${newCompNames}}) => {${callbackCode}
})`;
            result.code = code2;
          }
          if (ssr) {
            const normalizedId = _vite.normalizePath.call(void 0, _path3.default.relative(root, id));
            let ssrInjectCode = `
import { ssrRegisterHelper } from "${ssrRegisterHelperId}"
const __moduleId = ${JSON.stringify(normalizedId)}`;
            for (const { local } of hotComponents) {
              ssrInjectCode += `
ssrRegisterHelper(${local}, __moduleId)`;
            }
            result.code += ssrInjectCode;
          }
        }
        if (!result.code) {
          return;
        }
        return {
          code: result.code,
          map: result.map
        };
      }
    }
  };
}
function parseComponentDecls(node, fnNames) {
  const names = [];
  for (const decl of node.declarations) {
    if (decl.id.type === "Identifier" && (isDefineComponentCall(decl.init, fnNames) || isClassComponentDefine(decl.init))) {
      names.push(decl.id.name);
    }
  }
  return names;
}
function isDefineComponentCall(node, names) {
  return node && node.type === "CallExpression" && node.callee.type === "Identifier" && names.includes(node.callee.name);
}
function isClassComponentDefine(node) {
  return node && node.type === "ClassExpression" && isExtendClassComponet(node);
}
function isExtendClassComponet(node) {
  return node && node.superClass && node.superClass.name === "VueComponent";
}
var _a;
var hash = (_a = _crypto2.default.hash) != null ? _a : (algorithm, data, outputEncoding) => _crypto2.default.createHash(algorithm).update(data).digest(outputEncoding);
function getHash(text) {
  return hash("sha256", text, "hex").substring(0, 8);
}
var index_default = vueJsxPlugin;


exports.default = index_default;

module.exports = exports.default;
